// --------------------------------------------------------------------
//  Windows Application Basic Classes
//  include file
//   HMENU MENU_IDɂāAWinLibł́A4000-4999,6000-6999́A\
//   ܂B
// --------------------------------------------------------------------

#ifndef _WINDOWS_LIB_CLASS_
#define _WINDOWS_LIB_CLASS_

#define WINLIB_CLASS_VERSION ".110"

#define ENABLE TRUE
#define DISABLE FALSE

int NoticeMessage(char *message) ;
int NoticeMessagef(char *format,...) ;

class WindowClass{
	private:
	  char IconName[32] ;
	  char MenuName[32] ;
	  char ClassName[32] ;
	protected:
	  HINSTANCE hI ;
	  WNDCLASSEX wc ;
	public:
	  WindowClass(HINSTANCE,WNDPROC,char *) ;
	  virtual ~WindowClass(){} ;
	  void SetIcon(char *) ;
	  void SetMenu(char *) ;
	  void SetBackground(int brush_type) ;
	  WNDCLASSEX *GetWndClass(void){ return(&wc) ; } ;
	  void SetCbWExtra(int cbex) ;
	  void SetAll(WNDCLASSEX) ;
	  ATOM Regist(void) ;
} ;

// --------------------------------------------------------------------
//class MainWindow{
//	private:
//	  HWND handleWnd ;
//	  HINSTANCE apInst ;
//	  DWORD     Style ;
//	  char ClassName[32] ;
//	public:
//	  MainWindow(HINSTANCE,char *) ;
//	  ~MainWindow(){} ;
//	  void SetStyle(DWORD) ;
//	  HWND Create(char *,int,int,int,int,BOOL) ;
//	  void Show(int) ;
//	  HWND GetHandle(void) ;
//	  WPARAM MessageLoop(void) ;
//} ;

//class MainWin : public WindowClass{
//	private:
//	  HWND handleWnd ;
//	  HINSTANCE apInst ;
//	  DWORD     Style ;
//	  char ClassName[32] ;
//	public:
//	  MainWin(HINSTANCE,WNDPROC,char *) ;
//	  ~MainWin(){} ;
//	  void SetStyle(DWORD) ;
//	  HWND Create(char *,int,int,int,int,BOOL) ;
//	  void Show(int) ;
//	  HWND GetHandle(void) ;
//	  WPARAM MessageLoop(void) ;
//	  int MessageBox(char *msg,char *captn,UINT typ) ;
//} ;

typedef union tagCOLORBYTES{
	long lcolor ;
	struct{
	  unsigned red:8 ;
	  unsigned green:8 ;
	  unsigned blue:8 ;
	  unsigned dummy:8 ;
	}param ;
} COLORBYTES ;

COLORREF RGBcolor(int r,int g,int b) ;

typedef struct tagCOLORSET{
	HWND     WNDHANDLE ;
	COLORREF TEXTCOLOR ;
	COLORREF TEXTBG ;
	HBRUSH   BACKGROUND ;
	int      SETPARAM ; // 0: no 1:TEXT_COLOR only 2:BKCOLOR 3:Both
} COLORSET ;

// --------------------------------------------------------------------
//  DragDropp
// --------------------------------------------------------------------

class tempString{
	private:
	  char *StrBuff ;
	  int  SLength ;
	public:
	  tempString(char *str){
	    SLength=strlen(str) ;
	    if(NULL==(StrBuff=(char *)malloc(SLength+2))) SLength=0 ;
	    else strcpy(StrBuff,str) ;
	  } ;
	  ~tempString(){
	    if(SLength) free(StrBuff) ;
	  }
	  int length(void){ return(SLength) ; } ;
	  char *get(void){ return(StrBuff) ; } ;
} ;

#define DRAGDROPMAX 256

class DragDrop{
	private:
	  tempString *tmpFname[DRAGDROPMAX] ;
	  char tmpFN[256] ;
	  int DropCount ;
	  HDROP handleDrop ;
	  BOOL compare_extention(char *ext) ;
	public:
	  DragDrop(WPARAM wParam) ;
	  ~DragDrop() ;
	  int Count(void){ return(DropCount) ; } ;
	  char *GetFilename(char *search_extention) ;
	  char *GetFilename(int number){
	    if(number>=0 && number<DropCount) return(tmpFname[number]->get()) ;
	    else return(NULL) ;
	  }
} ;

// --------------------------------------------------------------------
//  ̃NX́Ap鎖ړIƂč쐬B

#define IDT_TIMER_001   4000
#define IDUSR_COLORINFO (WPARAM)4500

class WinApp{
	private:
	  DWORD     Style ;
	  char      ClassName[32] ;
	  BOOL      UseCommon ;
	  BOOL      UseTimer ;
	  BOOL      UseDrop ;
	  DWORD     dwExStyle ;
	  COLORSET  CWndColor[256] ;
	  int       ColorCount ;
	  void      InitialWinApp(HINSTANCE hi,WNDPROC WPRC,char *Cname) ;
	  LRESULT   ControlChildColor(HDC childDC,HWND childHnd) ;
	protected:
	  HWND handleWnd ;
	  HINSTANCE apInst ;
	public:
	  WinApp(HINSTANCE,WNDPROC,char *) ;
	  WinApp(HINSTANCE,char *) ;
	  WinApp(HINSTANCE) ;
	  virtual ~WinApp(){ delete WndClass ; } ;
	  WindowClass *WndClass ;
	  void SetStyle(DWORD) ;
	  void SetExStyle(DWORD) ;
	  HWND Create(char *,int,int,int,int,BOOL) ;
	  void Show(int) ;
	  HWND GetHandle(void) ;
	  WPARAM MessageLoop(void) ;
	  int MessageBox(char *msg,char *captn,UINT typ) ;
	  void    StartTimer(UINT timeup){
	    if(UseTimer) return ; // P
	    SetTimer(handleWnd,IDT_TIMER_001,timeup,NULL) ;
	    UseTimer=TRUE ;
	  } ;
	  void    StopTimer(void){
	    KillTimer(handleWnd,IDT_TIMER_001) ;
	    UseTimer=FALSE ;
	  } ;
	  void Drop(BOOL sw){
	    DragAcceptFiles(handleWnd,sw) ;
	    UseDrop=sw ;
	  }
	  char *GetDropFilename(WPARAM wP,char *extention) ;
	  void    ChildWndPartsColor(LPARAM lP) ;
	  void    ChildWndColor(COLORSET *tmpColor) ;
	  virtual LRESULT WindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam) ;
	  virtual void OnCreate(HWND){} ;
	  virtual void OnDestroy(HWND){
	    if(UseTimer) StopTimer() ; // gĂꍇ̓^C}[̒~
	    if(UseDrop) Drop(DISABLE) ;
	    PostQuitMessage(0) ; 
	  } ;
	  virtual void OnSize(HWND,WPARAM,LPARAM){} ;
	  virtual void OnPaint(HWND,HDC){} ;
	  virtual LRESULT OnCtlColor(HWND,UINT,WPARAM,LPARAM) ;
	  virtual void OnCommand(HWND,WPARAM,LPARAM){} ;
	  virtual void OnUser(HWND,WPARAM,LPARAM){} ;
	  virtual void OnTimer(HWND,WPARAM,LPARAM){} ;
	  virtual void OnDrop(HWND,WPARAM){} ;
	  // Œ`Ă郁bZ[WȊȌꍇ̃nh
	  // KTRUEFALSEԂCFALSEԂꍇ́A
	  // DefWindowProcĂ΂B܂AIe
	  // ɂẮATRUEԂȂFALSEԂΗǂB
	  virtual BOOL OnDefault(HWND,UINT,WPARAM,LPARAM){ return(FALSE) ; } ;
	  virtual void UserFunc1(HWND,WPARAM,LPARAM){} ;
	  virtual void UserFunc2(HWND,WPARAM,LPARAM){} ;
	  virtual void UserFunc3(HWND,WPARAM,LPARAM){} ;
} ;

// --------------------------------------------------------------------------
// FrameWindowNX́A΁AvO}̐_ׁ̈AWinMainȑfɂ
// ړIƂĒ`BႦ΁ARegist烁bZ[W[v܂ł̗́A
// T܂Ă̂ŁA̕ӂZ߂ɂāAFrameWork()ƌ\hŁA
// WinMain̖߂l܂ŁAʓ|悤Ƃ݂łB
// i̔zúAWinApp::OnCreate()ӂłƌɂB
// ʁAvO}́AWinApppNXAIɐ錾WinApp*^
// newȂ΂ȂȂ̂ŁAWinMain̍Ōɂ́AKdeleteKvɂȂ邪A
// ̃NX́AÓIɐ錾ôŁAvO}AWinApp̔hNX
// newēn΁ÅǗdelete܂ŁAɂĂB
// {Iɂ́ÃNX̃\bh́ARXgN^ƁA
// FrameWork݂̂Ȃ̂ŁAWinMain̐擪ŐAreturn(FrameWork(..))ŕ߂
// ǂBAÅԂɁAׂꍇ́AWinApp *FrameObjectA
// publicŐ錾Ă̂ŁA̒ōsΗǂB
// ɂĂA쐬WinApṕAfXgN^deleteB
// ̑FŌCreateFrameWindow̃nhA
//         HANDLEFrameWindowƌϐ extern񋟂B
//         ʏAWinMainō쐬FrameWindow͂P(Ǝv)̂ŁA
//         ꂪ{Iɂ́AC̃EChEnhƂȂB
// ------------------------------------------------------------------------

typedef WinApp* WINDOWAPPS ;
extern HWND    HANDLEFrameWindow ;

class FrameWindow{
	private:
	  HINSTANCE PrevIns ;
	  int   NComS ;
	  BOOL  FWENABLE ;
	  void init(WINDOWAPPS WApp,HINSTANCE PrevI,int nCmdShow) ;
	public:
	  WINDOWAPPS FrameObject ;
	  FrameWindow(WINDOWAPPS WApp,HINSTANCE PrevI,int nCmdShow) ;
	  FrameWindow(WINDOWAPPS WApp,char *Menu,char *Icon,
	                         HINSTANCE PrevI,int nCmdShow) ;
	  FrameWindow(WINDOWAPPS WApp,WNDCLASSEX WcEx,
	                         HINSTANCE PrevI,int nCmdShow) ;
	  virtual ~FrameWindow(){
	    if(FrameObject) delete FrameObject ;
	  } ;
	  WPARAM FrameWork(char *title,int startx,int starty,
	                      int width,int height,BOOL SizeDetect) ;
	  WPARAM FrameWork(char *title,int width,int height) ;
	  WPARAM FrameWork(int width,int height) ; // p:title="Untitled"
} ;

// --------------------------------------------------------------------
// FONT class to create HFONT object
// --------------------------------------------------------------------

#define PSFONT_ARIAL 0
#define PSFONT_COURIER 1
#define PSFONT_MINCHO 2
#define PSFONT_GOTHIC 3

class CFONT{
	private:
	  LPCTSTR  lpszFace ;         // address of typeface name string 
	  HFONT hFont ;
	  char FontFace[128] ;
	public:
	  int  nHeight ;              // logical height of font 
	  int  nWidth ;               // logical average character width 
	  int  nEscapement ;          // angle of escapement 
	  int  nOrientation ;         // base-line orientation angle 
	  int  fnWeight ;             // font weight 
	  DWORD  fdwItalic ;          // italic attribute flag 
	  DWORD  fdwUnderline ;       // underline attribute flag 
	  DWORD  fdwStrikeOut ;       // strikeout attribute flag 
	  DWORD  fdwCharSet ;         // character set identifier 
	  DWORD  fdwOutputPrecision ; // output precision 
	  DWORD  fdwClipPrecision ;   // clipping precision 
	  DWORD  fdwQuality ;         // output quality 
	  DWORD  fdwPitchAndFamily ;  // pitch and family 
//
	  CFONT() ;
	  ~CFONT() ;
	  void set(char *facestr) ;
	  void set(char *facestr,int height,int angl=0) ;
	  void set(int height,int angl=0) ;
	  void angle(int angl) ;
	  void size(int height){ set(height) ; }
	  void use_Arial(int siz=0) ;
	  void use_Courier(int siz=0) ;
	  void use_MS_gothic(int siz=0) ;
	  void use_MS_mincho(int siz=0) ;
	  void use_Default(int siz=0) ;
	  void usePreset(int PsNumb,int siz) ;
	  HFONT Create(void) ;
	  BOOL Active(void){ return(hFont!=NULL) ; } ;
	  HFONT GetFont(void){ return(hFont) ; } ;
} ;

// --------------------------------------------------------------------
//  Common GUI Parts class
// --------------------------------------------------------------------

class GUIParts{
	protected:
	  HWND handleWnd,Parent ;
	  DWORD     Style ;
	  DWORD     dwExStyle ;
	  HMENU     Mid ;
	  char      PartsType[64] ;
	  COLORSET  thisColor ;
	  BOOL      FontReq ;
	  BOOL      ColorReq ;
	  void Initialize(char *PTyp,HWND PrntH,HMENU MnID,DWORD St) ;
	  void SetBGColorEx(int fnObject) ;
	  void SetPartsColor(void) ;
	public:
	  GUIParts(){} ;
	  virtual ~GUIParts(){} ;
	  void SetStyle(DWORD) ;
	  void AddStyle(DWORD) ;
	  void DecStyle(DWORD) ;
	  void SetExStyle(DWORD) ;
	  HWND Create(char *,int,int,int,int) ;
	  HWND GetHandle(void) ;
	  HMENU GetMenuID(void) ;
	  LRESULT SendMsg(UINT Msg,WPARAM wParam,LPARAM lParam) ;
	  void    PostMsg(UINT Msg,WPARAM wParam,LPARAM lParam) ;
	  BOOL  IsYourEvent(WPARAM mID) ;
	  void Enable(BOOL sw) ;
	  CFONT FONT ;
	  void SetFont(void) ;
	  void SetFont(char *FFace,int siz,int angl=0) ;
	  void SetFont(int FontPresetNumb,int siz,int angl=0) ;
	  void SetFont(HFONT hFont) ;
	  void SetFontColor(int r,int g,int b) ;
	  void SetFontColor(COLORREF col) ;
	  void SetTEXTBGColor(int r,int g,int b) ;
	  void SetTEXTBGColor(COLORREF col) ;
	  void SetBGColor(HBRUSH brush) ;
	  void SetBGColor(int fnObject) ;
} ;

class PushButton : public GUIParts{
	public:
	  PushButton(HWND ParentH,HMENU MenuID) ;
	  PushButton(HWND ParentH) ;
	  ~PushButton(){} ;
} ;

class RadioButton : public GUIParts{
	public:
	  RadioButton(HWND ParentH,HMENU MenuID) ;
	  RadioButton(HWND ParentH) ;
	  ~RadioButton(){} ;
	  void Check(BOOL sw) ;
	  BOOL Check(void) ;
} ;

class CheckBox : public GUIParts{
	public:
	  CheckBox(HWND ParentH,HMENU MenuID) ;
	  CheckBox(HWND ParentH) ;
	  ~CheckBox(){} ;
	  void Check(BOOL sw) ;
	  BOOL Check(void) ;
} ;

class SimpleEdit : public GUIParts{
	public:
	  SimpleEdit(HWND ParentH,HMENU MenuID,BOOL BORDER,BOOL SCROLL) ;
	  SimpleEdit(HWND ParentH,BOOL BORDER,BOOL SCROLL) ;
	  ~SimpleEdit(){} ;
	  void SingleLine(void) ;
	  void AddString(char *str) ;
	  void AddChar(int c) ;
	  void SetWindowText(char *txt) ;
	  void GetWindowText(char *txt,int len) ;
} ;

class Label : public GUIParts{
	public:
	  Label(HWND ParentH,HMENU MenuID,BOOL BORDER) ;
	  Label(HWND ParentH,BOOL BORDER) ;
	  ~Label(){} ;
	  void SetWindowText(char *txt) ;
	  void GetWindowText(char *txt,int len) ;
} ;

class ListBox : public GUIParts{
	public:
	  ListBox(HWND ParentH,HMENU MenuID) ;
	  ListBox(HWND ParentH) ;
	  ~ListBox(){} ;
	  void AddString(char *txt) ;
	  void SetCurSel(int pos) ;
	  int  GetSelected(char *txt) ;
} ;

class ComboBox : public GUIParts{
	public:
	  ComboBox(HWND ParentH,HMENU MenuID) ;
	  ComboBox(HWND ParentH) ;
	  ~ComboBox(){} ;
	  void Simple(void) ;
	  void AddString(char *txt) ;
	  void SetCurSel(int pos) ;
	  int  GetSelected(char *txt) ;
} ;

#define RBWMAX 64

class RadioBtnWork{
	private:
	  RadioButton *RB[RBWMAX] ;
	  char RBStr[RBWMAX][128] ;
	  BOOL RBS[RBWMAX] ;
	  int  mark ;
	  int  registed ;
	  HWND CommonPWND ;
	public:
	  RadioBtnWork(){
	    mark=registed=0 ;
	    CommonPWND=NULL ;
	  } ;
	  RadioBtnWork(HWND PWND){
	    mark=registed=0 ;
	    CommonPWND=PWND ;
	  } ;
	  ~RadioBtnWork(){ DeleteAll() ; } ;
	  void add(RadioButton *rbtn,char *wstr){
	    if(registed<RBWMAX){
	      RB[registed]=rbtn ;
	      setWndStr(registed,wstr) ;
	      RBS[registed]=FALSE ;
	      registed++ ;
	    }
	  } ;
	  void add(HWND PWH,char *wstr){
	    if(registed<RBWMAX){
	      RB[registed]=new RadioButton(PWH) ;
	      setWndStr(registed,wstr) ;
	      RBS[registed]=TRUE ; // new
	      registed++ ;
	    }
	  }
	  void add(char *wstr){
	    if(registed<RBWMAX && CommonPWND!=NULL){
	      RB[registed]=new RadioButton(CommonPWND) ;
	      setWndStr(registed,wstr) ;
	      RBS[registed]=TRUE ; // new
	      registed++ ;
	    }
	  }
	  void setWndStr(int nb,char *wstr) ;
	  void VirtCreate(int startx,int starty,int width,int each_height) ;
	  void HolzCreate(int startx,int starty,int each_width,int height) ;
	  void DeleteAll(void) ;
	  void Enable(BOOL sw) ;
	  void push(int nb) ;
	  BOOL IsYourJob(WPARAM wP) ;
	  int  selected(void){ return(mark) ; } ;
} ;

// --------------------------------------------------------------------
//

#define BOOTCTL_ON TRUE
#define BOOTCTL_OFF FALSE

class AppProfile{
	private:
	  char ProfileName[256] ;
	  BOOL BOOTCONT ;
	  BOOL BOOTCOND ;
	public:
	  AppProfile(char *name,BOOL BootCtl=BOOTCTL_OFF){
	    strcpy(ProfileName,name) ;
	    BOOTCONT=BootCtl ;
	    if(BOOTCONT){ // BOOT Control ON
	      if(BootEnable()){ // BOOT
	        BootEnable(FALSE) ; // BOOTsɐݒ
	        BOOTCOND=TRUE ; // BOOT
	      }
	      else BOOTCOND=FALSE ; // BOOTs
	    }
	  } ;
	  ~AppProfile(){
	    if(BOOTCONT){ // BOOT Control ON
	      if(BOOTCOND) // BOOT̏ꍇ̂݁AI
	        BootEnable(TRUE) ; // BOOTB
	    }
	  } ;
	  // }jAŐ䂷ꍇ̃\bh
	  void BootEnable(BOOL sw) ; // Profile[COMMON][BOOT]̒lݒ
	  int  BootEnable(void) ; // Profile[COMMON][BOOT]̒l(1/0)ԂB
	  //  BOOTCTL ON̏ꍇ̃\bh
	  BOOL BootCondition(void){ // 
	    if(BOOTCONT) return(BOOTCOND) ;
	    else return(FALSE) ;
	  }
	  void ForceBoot(void){
	    if(BOOTCONT) BOOTCOND=TRUE ;
	  }
	  void Write(char *Section,char *Name,char *value){
	    WritePrivateProfileString(Section,Name,value,ProfileName) ;
	  } ;
	  int GetInt(char *Section,char *Name){
	    return(GetPrivateProfileInt(Section,Name,-1,ProfileName)) ;
	  } ;
	  DWORD GetString(char *Section,char *Name,char *GetValue,int siz){
	    return(GetPrivateProfileString(Section,Name,"",GetValue,siz,ProfileName)) ;
	  } ;
	  // ܂
	  void CommPort(int numb) ;
	  int  CommPort(void) ;
} ;

#endif
